<template>
  <div
    class="settings-container"
  >
    <div class="title">Конфигурация автопоиска</div>
    <div class="radio-block">
      <ObRadio
        :value-input="settings.parallelAutosearch"
        :model-value="true"
        label="Букинг проходит одновременно с аукционом"
        @change="onSaveField('parallelAutosearch', true)"
      />
      <ObRadio
        :value-input="settings.parallelAutosearch"
        :model-value="false"
        label="Аукцион начинается после букинга"
        @change="onSaveField('parallelAutosearch', false)"
      />
    </div>
    <div class="title">Минимально допустимая продолжительность опроса</div>
    <div class="setting-row">
      <div class="setting-row__input">
        <ObInput
          :value="settings.autosearchMinimalDuration"
          label="Минимально"
          sub-title="мин"
          type="number:strict"
          placeholder="—"
          @blur="onSaveField('autosearchMinimalDuration', $event)"
        />
      </div>
      <div class="setting-row__description">
        <span>Время опроса не может быть менее минимально допустимой продолжительности, в противном случае (если до ПВП осталось слишком мало времени) автопоиск не запускается.</span>
      </div>
    </div>
    <div class="title">Запретительное значение рейтинга для участия в автопоиске</div>
    <div class="setting-row">
      <div class="setting-row__input">
        <ObStepper
          :model-value="settings.carrierRateMin"
          label="Рейтинг перевозчиков от"
          min-value="0"
          @input="onSaveField('carrierRateMin', $event)"
        />
      </div>
      <div class="setting-row__description">
        <span>К участию в аукционах и букинг-запросах будут допущены только перевозчики с рейтингом выше установленного</span>
      </div>
    </div>
    <div class="title">Начинать автопоиск с опережением по времени (лидтайм упреждения) не более:</div>
    <div class="setting-row">
      <div class="setting-row__input">
        <ObInput
          :value="settings.autosearchLeadtime / MINUTES_IN_HOURS"
          label="Не более"
          sub-title="ч"
          type="number:strict"
          placeholder="—"
          @blur="onSaveField('autosearchLeadtime', $event)"
        />
      </div>
      <div class="setting-row__description">
        <span>До ПВП</span>
      </div>
    </div>
    <div class="title">Заканчивать автопоиск и не начинать автопоиск, если осталось менее:</div>
    <div class="setting-row">
      <div class="setting-row__input">
        <ObInput
          :value="settings.autosearchStopPeriod"
          label="Осталось менее"
          sub-title="мин"
          type="number:strict"
          placeholder="—"
          @blur="onSaveField('autosearchStopPeriod', $event)"
        />
      </div>
      <div class="setting-row__description">
        <span>До ПВП</span>
      </div>
    </div>
  </div>
</template>

<script>
import { mapActions } from 'vuex'
import ObRadio from 'common-components/src/obComponents/obRadio'
import ObInput from 'common-components/src/obComponents/obInput'
import ObStepper from 'common-components/src/obComponents/obStepper'

export default {
  name: 'ClicarSettingsAutosearchCommonSettings',
  components: {
    ObRadio,
    ObInput,
    ObStepper
  },
  props: {
    settings: {
      type: Object,
      required: true
    }
  },
  methods: {
    ...mapActions({
      getAutosearchSettings: 'clicarSettings_3/getAutosearchSettings'
    }),
    onSaveField (path, event) {
      let value = event.target ? event.target.value : event

      this.$emit('on-save-field', { path, value })
    }
  },
  computed: {
    MINUTES_IN_HOURS () {
      return 60
    },
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.radio-block {
  margin-top: 2px;
  &::v-deep {
    .ob-radio-container + .ob-radio-container {
      margin-top: 4px;
    }
  }
}

.title {
  margin-top: 30px;
  margin-bottom: 10px;
  @include font-mixin(16px, 20px, 700, $color-text-base, 0.4px);
}

.setting-row {
  display: flex;
  align-items: center;
  &__input {
    width: 220px;
  }
  &__description {
    max-width: 440px;
    margin-left: 10px;
    @include font-mixin(14px, 18px, 400, $color-grey-label);
  }
}
</style>